Index: issm/trunk/src/c/classes/objects/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Tria.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Tria.cpp	(revision 13975)
@@ -3693,12 +3758,12 @@
 
 	/*Intermediaries*/
-	int        i,ig;
+	int        i;
 	int        doflist[NUMVERTICES];
-	IssmDouble     vx,vy,lambda,mu,thickness,Jdet;
-	IssmDouble     viscosity_complement;
-	IssmDouble     dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2],dZ[NDOF2]; 
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     basis[3],epsilon[3];
-	IssmDouble     grad[NUMVERTICES]={0.0};
+	IssmDouble vx,vy,lambda,mu,thickness,Jdet;
+	IssmDouble viscosity_complement;
+	IssmDouble dvx[NDOF2],dvy[NDOF2],dadjx[NDOF2],dadjy[NDOF2],dZ[NDOF2]; 
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble basis[3],epsilon[3];
+	IssmDouble grad[NUMVERTICES]={0.0};
 	GaussTria *gauss = NULL;
 
@@ -3717,5 +3782,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3749,16 +3814,16 @@
 void  Tria::GradjDragMacAyeal(Vector<IssmDouble>* gradient,int control_index){
 
-	int        i,ig;
+	int        i;
 	int        analysis_type;
-	int        doflist1[NUMVERTICES];
+	int        vertexpidlist[NUMVERTICES];
 	int        connectivity[NUMVERTICES];
-	IssmDouble     vx,vy,lambda,mu,alpha_complement,Jdet;
-	IssmDouble     bed,thickness,Neff,drag;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dk[NDOF2]; 
-	IssmDouble     grade_g[NUMVERTICES]={0.0};
-	IssmDouble     grade_g_gaussian[NUMVERTICES];
-	IssmDouble     basis[3];
-	IssmDouble     epsilon[3]; /* epsilon=[exx,eyy,exy];*/
+	IssmDouble vx,vy,lambda,mu,alpha_complement,Jdet;
+	IssmDouble bed,thickness,Neff,drag;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dk[NDOF2]; 
+	IssmDouble grade_g[NUMVERTICES]={0.0};
+	IssmDouble grade_g_gaussian[NUMVERTICES];
+	IssmDouble basis[3];
+	IssmDouble epsilon[3]; /* epsilon=[exx,eyy,exy];*/
 	Friction*  friction=NULL;
 	GaussTria  *gauss=NULL;
@@ -3769,5 +3834,5 @@
 	parameters->FindParam(&analysis_type,AnalysisTypeEnum);
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 	this->GetConnectivityList(&connectivity[0]);
 
@@ -3784,5 +3849,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3793,5 +3858,5 @@
 		/*Build alpha_complement_list: */
 		friction->GetAlphaComplement(&alpha_complement, gauss,VxEnum,VyEnum,VzEnum);
-	
+
 		dragcoefficient_input->GetInputValue(&drag, gauss);
 		adjointx_input->GetInputValue(&lambda, gauss);
@@ -3805,5 +3870,5 @@
 			grade_g_gaussian[i]=-2*drag*alpha_complement*((lambda*vx+mu*vy))*Jdet*gauss->weight*basis[i];
 		}
-		
+
 		/*Add gradje_g_gaussian vector to gradje_g: */
 		for(i=0;i<NUMVERTICES;i++){
@@ -3827,5 +3892,5 @@
 	/*End Analytical gradient*/
 
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3837,11 +3902,11 @@
 void  Tria::GradjDragGradient(Vector<IssmDouble>* gradient, int weight_index,int control_index){
 
-	int        i,ig;
-	int        doflist1[NUMVERTICES];
-	IssmDouble     Jdet,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dbasis[NDOF2][NUMVERTICES];
-	IssmDouble     dk[NDOF2]; 
-	IssmDouble     grade_g[NUMVERTICES]={0.0};
+	int        i;
+	int        vertexpidlist[NUMVERTICES];
+	IssmDouble Jdet,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dbasis[NDOF2][NUMVERTICES];
+	IssmDouble dk[NDOF2]; 
+	IssmDouble grade_g[NUMVERTICES]={0.0};
 	GaussTria  *gauss=NULL;
 
@@ -3849,5 +3914,5 @@
 	if(IsFloating())return;
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 	Input* dragcoefficient_input=inputs->GetInput(FrictionCoefficientEnum); _assert_(dragcoefficient_input);
 	Input* weights_input=inputs->GetInput(InversionCostFunctionsCoefficientsEnum);                 _assert_(weights_input);
@@ -3855,5 +3920,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3872,5 +3937,5 @@
 		}
 	}
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3882,14 +3947,14 @@
 
 	/*Intermediaries*/
-	int    doflist1[NUMVERTICES];
+	int    vertexpidlist[NUMVERTICES];
 	IssmDouble lambda[NUMVERTICES];
 	IssmDouble gradient_g[NUMVERTICES];
 
 	/*Compute Gradient*/
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 	GetInputListOnVertices(&lambda[0],AdjointEnum);
 	for(int i=0;i<NUMVERTICES;i++) gradient_g[i]=-lambda[i];
 
-	gradient->SetValues(NUMVERTICES,doflist1,gradient_g,INS_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,gradient_g,INS_VAL);
 }
 /*}}}*/
@@ -3898,16 +3963,16 @@
 
 	/*Intermediaries*/
-	int        i,ig;
-	int        doflist1[NUMVERTICES];
-	IssmDouble     thickness,Jdet;
-	IssmDouble     basis[3];
-	IssmDouble     Dlambda[2],dp[2];
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     grade_g[NUMVERTICES] = {0.0};
+	int        i;
+	int        vertexpidlist[NUMVERTICES];
+	IssmDouble thickness,Jdet;
+	IssmDouble basis[3];
+	IssmDouble Dlambda[2],dp[2];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble grade_g[NUMVERTICES] = {0.0};
 	GaussTria *gauss                = NULL;
 
 	/* Get node coordinates and dof list: */
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 
 	/*Retrieve all inputs we will be needing: */
@@ -3917,5 +3982,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3923,5 +3988,5 @@
 		GetJacobianDeterminant2d(&Jdet, &xyz_list[0][0],gauss);
 		GetNodalFunctions(basis, gauss);
-		
+
 		adjoint_input->GetInputDerivativeValue(&Dlambda[0],&xyz_list[0][0],gauss);
 		thickness_input->GetInputValue(&thickness, gauss);
@@ -3931,5 +3996,5 @@
 	}
 
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3941,16 +4006,16 @@
 
 	/*Intermediaries*/
-	int        i,ig;
-	int        doflist1[NUMVERTICES];
-	IssmDouble     thickness,Jdet;
-	IssmDouble     basis[3];
-	IssmDouble     Dlambda[2],dp[2];
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     grade_g[NUMVERTICES] = {0.0};
+	int        i;
+	int        vertexpidlist[NUMVERTICES];
+	IssmDouble thickness,Jdet;
+	IssmDouble basis[3];
+	IssmDouble Dlambda[2],dp[2];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble grade_g[NUMVERTICES] = {0.0};
 	GaussTria *gauss                = NULL;
 
 	/* Get node coordinates and dof list: */
 	GetVerticesCoordinates(&xyz_list[0][0], nodes, NUMVERTICES);
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 
 	/*Retrieve all inputs we will be needing: */
@@ -3960,5 +4025,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -3973,5 +4038,5 @@
 		for(i=0;i<NUMVERTICES;i++) grade_g[i]+=thickness*Dlambda[1]*Jdet*gauss->weight*basis[i];
 	}
-	gradient->SetValues(NUMVERTICES,doflist1,grade_g,ADD_VAL);
+	gradient->SetValues(NUMVERTICES,vertexpidlist,grade_g,ADD_VAL);
 
 	/*Clean up and return*/
@@ -3988,5 +4053,5 @@
 	/*get gradient indices*/
 	for(int i=0;i<NUMVERTICES;i++){
-		indexing[i]=num_controls*this->nodes[i]->GetVertexDof() + control_index;
+		indexing[i]=num_controls*this->nodes[i]->GetVertexPid() + control_index;
 	}
 
@@ -3997,10 +4062,9 @@
 
 	/* Intermediaries */
-	int        ig;
-	IssmDouble     Jelem = 0;
-	IssmDouble     weight;
-	IssmDouble     Jdet;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dp[NDOF2];
+	IssmDouble Jelem = 0;
+	IssmDouble weight;
+	IssmDouble Jdet;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dp[NDOF2];
 	GaussTria *gauss = NULL;
 
@@ -4017,5 +4081,5 @@
 	/* Start looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4040,11 +4104,8 @@
 IssmDouble Tria::SurfaceAverageVelMisfit(bool process_units,int weight_index){
 
-	const int    numdof=2*NUMVERTICES;
-
-	int        i,ig;
-	IssmDouble     Jelem=0,S,Jdet;
-	IssmDouble     misfit;
-	IssmDouble     vx,vy,vxobs,vyobs,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble Jelem=0,S,Jdet;
+	IssmDouble misfit;
+	IssmDouble vx,vy,vxobs,vyobs,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
 	GaussTria *gauss=NULL;
 
@@ -4065,5 +4126,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(3);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4101,14 +4162,11 @@
 IssmDouble Tria::SurfaceLogVelMisfit(bool process_units,int weight_index){
 
-	const int    numdof=NDOF2*NUMVERTICES;
-
-	int        i,ig;
-	IssmDouble     Jelem=0;
-	IssmDouble     misfit,Jdet;
-	IssmDouble     epsvel=2.220446049250313e-16;
-	IssmDouble     meanvel=3.170979198376458e-05; /*1000 m/yr*/
-	IssmDouble     velocity_mag,obs_velocity_mag;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     vx,vy,vxobs,vyobs,weight;
+	IssmDouble Jelem=0;
+	IssmDouble misfit,Jdet;
+	IssmDouble epsvel=2.220446049250313e-16;
+	IssmDouble meanvel=3.170979198376458e-05; /*1000 m/yr*/
+	IssmDouble velocity_mag,obs_velocity_mag;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble vx,vy,vxobs,vyobs,weight;
 	GaussTria *gauss=NULL;
 
@@ -4128,5 +4186,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4166,14 +4224,11 @@
 IssmDouble Tria::SurfaceLogVxVyMisfit(bool process_units,int weight_index){
 
-	const int    numdof=NDOF2*NUMVERTICES;
-
-	int        i,ig;
 	int        fit=-1;
-	IssmDouble     Jelem=0, S=0;
-	IssmDouble     epsvel=2.220446049250313e-16;
-	IssmDouble     meanvel=3.170979198376458e-05; /*1000 m/yr*/
-	IssmDouble     misfit, Jdet;
-	IssmDouble     vx,vy,vxobs,vyobs,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble Jelem=0, S=0;
+	IssmDouble epsvel=2.220446049250313e-16;
+	IssmDouble meanvel=3.170979198376458e-05; /*1000 m/yr*/
+	IssmDouble misfit, Jdet;
+	IssmDouble vx,vy,vxobs,vyobs,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
 	GaussTria *gauss=NULL;
 
@@ -4190,8 +4245,8 @@
 	Input* vxobs_input  =inputs->GetInput(InversionVxObsEnum);     _assert_(vxobs_input);
 	Input* vyobs_input  =inputs->GetInput(InversionVyObsEnum);     _assert_(vyobs_input);
-	
+
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4232,11 +4287,8 @@
 IssmDouble Tria::SurfaceAbsVelMisfit(bool process_units,int weight_index){
 
-	const int    numdof=NDOF2*NUMVERTICES;
-
-	int        i,ig;
-	IssmDouble     Jelem=0;
-	IssmDouble     misfit,Jdet;
-	IssmDouble     vx,vy,vxobs,vyobs,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble Jelem=0;
+	IssmDouble misfit,Jdet;
+	IssmDouble vx,vy,vxobs,vyobs,weight;
+	IssmDouble xyz_list[NUMVERTICES][3];
 	GaussTria *gauss=NULL;
 
@@ -4256,5 +4308,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4292,14 +4344,12 @@
 /*FUNCTION Tria::SurfaceRelVelMisfit {{{*/
 IssmDouble Tria::SurfaceRelVelMisfit(bool process_units,int weight_index){
-	const int  numdof=2*NUMVERTICES;
-
-	int        i,ig;
-	IssmDouble     Jelem=0;
-	IssmDouble     scalex=1,scaley=1;
-	IssmDouble     misfit,Jdet;
-	IssmDouble     epsvel=2.220446049250313e-16;
-	IssmDouble     meanvel=3.170979198376458e-05; /*1000 m/yr*/
-	IssmDouble     vx,vy,vxobs,vyobs,weight;
-	IssmDouble     xyz_list[NUMVERTICES][3];
+
+	IssmDouble  Jelem=0;
+	IssmDouble  scalex=1,scaley=1;
+	IssmDouble  misfit,Jdet;
+	IssmDouble  epsvel=2.220446049250313e-16;
+	IssmDouble  meanvel=3.170979198376458e-05; /*1000 m/yr*/
+	IssmDouble  vx,vy,vxobs,vyobs,weight;
+	IssmDouble  xyz_list[NUMVERTICES][3];
 	GaussTria *gauss=NULL;
 
@@ -4319,5 +4369,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4358,10 +4408,9 @@
 
 	/* Intermediaries */
-	int        ig;
-	IssmDouble     Jelem = 0;
-	IssmDouble     weight;
-	IssmDouble     Jdet;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dp[NDOF2];
+	IssmDouble Jelem = 0;
+	IssmDouble weight;
+	IssmDouble Jdet;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dp[NDOF2];
 	GaussTria *gauss = NULL;
 
@@ -4378,5 +4427,5 @@
 	/* Start looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4402,5 +4451,4 @@
 
 	/* Intermediaries */
-	int         ig;
 	IssmDouble  Jelem = 0;
 	IssmDouble  weight;
@@ -4425,5 +4473,5 @@
 	/* Start looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4454,5 +4502,4 @@
 
 	/* Intermediaries */
-	int         ig;
 	IssmDouble  Jelem = 0;
 	IssmDouble  weight;
@@ -4477,5 +4524,5 @@
 	/* Start looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4506,11 +4553,10 @@
 
 	/*Intermediaries*/
-	int        i,ig;
-	IssmDouble     thickness,thicknessobs,weight;
-	IssmDouble     Jdet;
-	IssmDouble     Jelem = 0;
-	IssmDouble     xyz_list[NUMVERTICES][3];
+	IssmDouble thickness,thicknessobs,weight;
+	IssmDouble Jdet;
+	IssmDouble Jelem = 0;
+	IssmDouble xyz_list[NUMVERTICES][3];
 	GaussTria *gauss = NULL;
-	IssmDouble     dH[2];
+	IssmDouble dH[2];
 
 	/*If on water, return 0: */
@@ -4525,5 +4571,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4554,5 +4600,5 @@
 
 	/*Intermediaries */
-	int         i,ig,resp;
+	int         i,resp;
 	IssmDouble  Jdet;
 	IssmDouble  thickness,thicknessobs,weight;
@@ -4581,5 +4627,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4641,5 +4687,5 @@
 
 	/*Intermediaries */
-	int        i,resp,ig;
+	int        i,resp;
 	int       *responses=NULL;
 	int        num_responses;
@@ -4677,5 +4723,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -4823,5 +4869,5 @@
 
 	/*Intermediaries */
-	int        i,resp,ig;
+	int        i,resp;
 	int       *responses=NULL;
 	int        num_responses;
@@ -4859,5 +4905,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(4);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5006,10 +5052,9 @@
 
 	/* Intermediaries */
-	int        ig;
-	IssmDouble     Jelem = 0;
-	IssmDouble     weight;
-	IssmDouble     Jdet;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dp[NDOF2];
+	IssmDouble Jelem = 0;
+	IssmDouble weight;
+	IssmDouble Jdet;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dp[NDOF2];
 	GaussTria *gauss = NULL;
 
@@ -5026,5 +5071,5 @@
 	/* Start looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5075,15 +5120,14 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
+	int        i,j;
 	bool       incomplete_adjoint;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     Jdet,thickness;
-	IssmDouble     eps1dotdphii,eps1dotdphij;
-	IssmDouble     eps2dotdphii,eps2dotdphij;
-	IssmDouble     mu_prime;
-	IssmDouble     epsilon[3];/* epsilon=[exx,eyy,exy];*/
-	IssmDouble     eps1[2],eps2[2];
-	IssmDouble     phi[NUMVERTICES];
-	IssmDouble     dphi[2][NUMVERTICES];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble Jdet,thickness;
+	IssmDouble eps1dotdphii,eps1dotdphij;
+	IssmDouble eps2dotdphii,eps2dotdphij;
+	IssmDouble mu_prime;
+	IssmDouble epsilon[3];/* epsilon=[exx,eyy,exy];*/
+	IssmDouble eps1[2],eps2[2];
+	IssmDouble dphi[2][NUMVERTICES];
 	GaussTria *gauss=NULL;
 
@@ -5101,5 +5145,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5205,5 +5249,5 @@
 void  Tria::GetVectorFromControlInputs(Vector<IssmDouble>* vector,int control_enum,int control_index,const char* data){
 
-	int doflist1[NUMVERTICES];
+	int vertexpidlist[NUMVERTICES];
 	Input *input=NULL;
 
@@ -5212,5 +5256,5 @@
 
 	/*Prepare index list*/
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 
 	/*Get input (either in element or material)*/
@@ -5227,5 +5271,5 @@
 	}
 
-	((ControlInput*)input)->GetVectorFromInputs(vector,&doflist1[0],data);
+	((ControlInput*)input)->GetVectorFromInputs(vector,&vertexpidlist[0],data);
 }
 /*}}}*/
@@ -5234,5 +5278,5 @@
 
 	IssmDouble  values[NUMVERTICES];
-	int     doflist1[NUMVERTICES];
+	int     vertexpidlist[NUMVERTICES];
 	Input  *input     = NULL;
 	Input  *new_input = NULL;
@@ -5242,9 +5286,9 @@
 
 	/*Prepare index list*/
-	GradientIndexing(&doflist1[0],control_index);
+	GradientIndexing(&vertexpidlist[0],control_index);
 
 	/*Get values on vertices*/
 	for (int i=0;i<NUMVERTICES;i++){
-		values[i]=vector[doflist1[i]];
+		values[i]=vector[vertexpidlist[i]];
 	}
 	new_input = new TriaP1Input(control_enum,values);
@@ -5296,5 +5340,5 @@
 	/* compute VelocityFactor */
 	VelocityFactor= n_man*CR*CR*rho_water*g/mu_water;
-	
+
 	gauss=new GaussTria();
 	for (int iv=0;iv<NUMVERTICES;iv++){
@@ -5325,21 +5369,20 @@
 
 	/*Constants*/
-	const int    numdof=NDOF1*NUMVERTICES;
+	const int  numdof=NDOF1*NUMVERTICES;
 
 	/*Intermediaries */
-	IssmDouble     diffusivity;
-	int        i,j,ig;
-	IssmDouble     Jdettria,DL_scalar,dt,h;
-	IssmDouble     vx,vy,vel,dvxdx,dvydy;
-	IssmDouble     dvx[2],dvy[2];
-	IssmDouble     v_gauss[2]={0.0};
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     L[NUMVERTICES];
-	IssmDouble     B[2][NUMVERTICES];
-	IssmDouble     Bprime[2][NUMVERTICES];
-	IssmDouble     K[2][2]                        ={0.0};
-	IssmDouble     KDL[2][2]                      ={0.0};
-	IssmDouble     DL[2][2]                        ={0.0};
-	IssmDouble     DLprime[2][2]                   ={0.0};
+	IssmDouble diffusivity;
+	IssmDouble Jdettria,DL_scalar,dt,h;
+	IssmDouble vx,vy,vel,dvxdx,dvydy;
+	IssmDouble dvx[2],dvy[2];
+	IssmDouble v_gauss[2]={0.0};
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble L[NUMVERTICES];
+	IssmDouble B[2][NUMVERTICES];
+	IssmDouble Bprime[2][NUMVERTICES];
+	IssmDouble K[2][2]                        ={0.0};
+	IssmDouble KDL[2][2]                      ={0.0};
+	IssmDouble DL[2][2]                        ={0.0};
+	IssmDouble DLprime[2][2]                   ={0.0};
 	GaussTria *gauss=NULL;
 
@@ -5363,5 +5406,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5433,10 +5476,10 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     Jdettria,dt;
-	IssmDouble     basal_melting_g;
-	IssmDouble     old_watercolumn_g;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     basis[numdof];
+	int        i,j;
+	IssmDouble Jdettria,dt;
+	IssmDouble basal_melting_g;
+	IssmDouble old_watercolumn_g;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble basis[numdof];
 	GaussTria* gauss=NULL;
 
@@ -5456,5 +5499,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5469,5 +5512,5 @@
 		else  for(i=0;i<numdof;i++) pe->values[i]+=Jdettria*gauss->weight*basal_melting_g*basis[i];
 	}
-		
+
 	/*Clean up and return*/
 	delete gauss;
@@ -5541,5 +5584,5 @@
 /*FUNCTION Tria::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type);{{{*/
 void  Tria::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){
-	
+
 	int i,j;
 
@@ -5556,5 +5599,5 @@
 			/*Get values on the 3 vertices*/
 			for (i=0;i<3;i++){
-				values[i]=vector[this->nodes[i]->GetSidList()]; //careful, vector of values here is not parallel distributed, but serial distributed (from a serial Dakota core!)
+				values[i]=vector[this->nodes[i]->GetVertexSid()]; //careful, vector of values here is not parallel distributed, but serial distributed (from a serial Dakota core!)
 			}
 
@@ -5567,5 +5610,5 @@
 					IssmDouble  surface[3];
 					IssmDouble  bed[3];
-					
+
 					/*retrieve inputs: */
 					GetInputListOnVertices(&thickness_init[0],ThicknessEnum);
@@ -5640,5 +5683,5 @@
 /*FUNCTION Tria::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols, int name, int type);{{{*/
 void  Tria::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols, int name, int type){
-	
+
 	int i,j,t;
 	TransientInput* transientinput=NULL;
@@ -5654,7 +5697,7 @@
 
 		case VertexEnum:
-			
+
 			/*Create transient input: */
-						
+
 			parameters->FindParam(&yts,ConstantsYtsEnum);
 			for(t=0;t<ncols;t++){ //ncols is the number of times
@@ -5662,5 +5705,5 @@
 				/*create input values: */
 				for(i=0;i<3;i++){
-					row=this->nodes[i]->GetSidList();
+					row=this->nodes[i]->GetVertexSid();
 					values[i]=(IssmDouble)matrix[ncols*row+t];
 				}
@@ -5707,16 +5750,16 @@
 	/*Intermediaries */
 	int        stabilization;
-	int        i,j,ig,dim;
-	IssmDouble     Jdettria,vx,vy,dvxdx,dvydy,vel,h;
-	IssmDouble     dvx[2],dvy[2];
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     L[NUMVERTICES];
-	IssmDouble     B[2][NUMVERTICES];
-	IssmDouble     Bprime[2][NUMVERTICES];
-	IssmDouble     K[2][2]                          = {0.0};
-	IssmDouble     KDL[2][2]                        = {0.0};
-	IssmDouble     DL[2][2]                         = {0.0};
-	IssmDouble     DLprime[2][2]                    = {0.0};
-	IssmDouble     DL_scalar;
+	int        i,j,dim;
+	IssmDouble Jdettria,vx,vy,dvxdx,dvydy,vel,h;
+	IssmDouble dvx[2],dvy[2];
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble L[NUMVERTICES];
+	IssmDouble B[2][NUMVERTICES];
+	IssmDouble Bprime[2][NUMVERTICES];
+	IssmDouble K[2][2]                          = {0.0};
+	IssmDouble KDL[2][2]                        = {0.0};
+	IssmDouble DL[2][2]                         = {0.0};
+	IssmDouble DLprime[2][2]                    = {0.0};
+	IssmDouble DL_scalar;
 	GaussTria *gauss                            = NULL;
 
@@ -5742,5 +5785,5 @@
 	/*Start looping on the number of gaussian points:*/
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5816,11 +5859,11 @@
 
 	/*Intermediaries*/
-	int        i,j,ig,dim;
-	IssmDouble     vx,vy,Jdettria;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     B[2][NUMVERTICES];
-	IssmDouble     Bprime[2][NUMVERTICES];
-	IssmDouble     DL[2][2]={0.0};
-	IssmDouble     DL_scalar;
+	int        i,j,dim;
+	IssmDouble vx,vy,Jdettria;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble B[2][NUMVERTICES];
+	IssmDouble Bprime[2][NUMVERTICES];
+	IssmDouble DL[2][2]={0.0};
+	IssmDouble DL_scalar;
 	GaussTria  *gauss=NULL;
 
@@ -5836,5 +5879,5 @@
 	/*Start looping on the number of gaussian points:*/
 	gauss=new GaussTria(2);
-	for (ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5882,10 +5925,10 @@
 	/*Constants*/
 	const int    numdof=NDOF1*NUMVERTICES;
-	
+
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     dhdt_g,basal_melting_g,surface_mass_balance_g,Jdettria;
-	IssmDouble     L[NUMVERTICES];
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble dhdt_g,basal_melting_g,surface_mass_balance_g,Jdettria;
+	IssmDouble L[NUMVERTICES];
 	GaussTria* gauss=NULL;
 
@@ -5898,8 +5941,8 @@
 	Input* basal_melting_input=inputs->GetInput(BasalforcingsMeltingRateEnum);          _assert_(basal_melting_input);
 	Input* dhdt_input=inputs->GetInput(BalancethicknessThickeningRateEnum);             _assert_(dhdt_input);
-	
+
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
@@ -5927,8 +5970,8 @@
 
 	/*Intermediaries */
-	int        i,j,ig;
-	IssmDouble     xyz_list[NUMVERTICES][3];
-	IssmDouble     basal_melting_g,surface_mass_balance_g,dhdt_g,Jdettria;
-	IssmDouble     L[NUMVERTICES];
+	int        i,j;
+	IssmDouble xyz_list[NUMVERTICES][3];
+	IssmDouble basal_melting_g,surface_mass_balance_g,dhdt_g,Jdettria;
+	IssmDouble L[NUMVERTICES];
 	GaussTria* gauss=NULL;
 
@@ -5944,5 +5987,5 @@
 	/* Start  looping on the number of gaussian points: */
 	gauss=new GaussTria(2);
-	for(ig=gauss->begin();ig<gauss->end();ig++){
+	for(int ig=gauss->begin();ig<gauss->end();ig++){
 
 		gauss->GaussPoint(ig);
Index: issm/trunk/src/c/classes/objects/Elements/Tria.h
===================================================================
--- issm/trunk/src/c/classes/objects/Elements/Tria.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Elements/Tria.h	(revision 13975)
@@ -29,15 +29,15 @@
 	public:
 
-		int  id;
-		int  sid;
-
-		Node   **nodes;    // 3 nodes
-		Material  *material;   // 1 material ice
-		Matpar  *matpar;   // 1 material parameter
-		int      horizontalneighborsids[3];
-
-		Parameters *parameters;   //pointer to solution parameters
-		Inputs     *inputs;
-		Results    *results;
+		int          id;
+		int          sid;
+
+		Node       **nodes;                       // 3 nodes
+		Material    *material;                    // 1 material ice
+		Matpar      *matpar;                      // 1 material parameter
+		int          horizontalneighborsids[3];
+
+		Parameters  *parameters;                  //pointer to solution parameters
+		Inputs      *inputs;
+		Results     *results;
 
 		/*Tria constructors, destructors {{{*/
@@ -47,10 +47,9 @@
 		/*}}}*/
 		/*Object virtual functions definitions:{{{ */
-		void  Echo();
-		void  DeepEcho();
-		int   Id(); 
-		int   MyRank();
-		int   ObjectEnum();
-		Object* copy();
+		void    Echo();
+		void    DeepEcho();
+		int     Id();
+		int     ObjectEnum();
+		Object *copy();
 		/*}}}*/
 		/*Update virtual functions resolution: {{{*/
@@ -77,4 +76,5 @@
 		void   Configure(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters);
 		void   SetCurrentConfiguration(Elements* elements,Loads* loads,DataSet* nodes,Materials* materials,Parameters* parameters);
+		void   SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		void   CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,Vector<IssmDouble>* df);
 		void   CreatePVector(Vector<IssmDouble>* pf);
@@ -82,4 +82,6 @@
 		void   Delta18oParameterization(void);
 		int    GetNodeIndex(Node* node);
+		int    GetNumberOfNodes(void);
+		void   GetNodesSidList(int* sidlist);
 		int    Sid();
 		bool   IsOnBed();
@@ -137,5 +139,4 @@
 		#endif
 
-
 		#ifdef _HAVE_CONTROL_
 		IssmDouble DragCoefficientAbsGradient(bool process_units,int weight_index);
@@ -190,6 +191,6 @@
 		int            GetElementType(void);
 		void	         GetDofList(int** pdoflist,int approximation_enum,int setenum);
-		void	         GetDofList1(int* doflist);
-		void           GetSidList(int* sidlist);
+		void	         GetVertexPidList(int* doflist);
+		void           GetVertexSidList(int* sidlist);
 		void           GetConnectivityList(int* connectivity);
 		void           GetInputListOnVertices(IssmDouble* pvalue,int enumtype);
@@ -203,5 +204,5 @@
 		void	         SetClone(int* minranks);
 		void	         SurfaceNormal(IssmDouble* surface_normal, IssmDouble xyz_list[3][3]);
-		
+
 		#ifdef _HAVE_DIAGNOSTIC_
 		ElementMatrix* CreateKMatrixDiagnosticMacAyeal(void);
